#if !defined(AFX_DATAOBJ_H__B5C0B4E1_5CA0_11D4_9F3D_009027A4D0CE__INCLUDED_)
#define AFX_DATAOBJ_H__B5C0B4E1_5CA0_11D4_9F3D_009027A4D0CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DataObj.h : header file
//

typedef struct tagCOLUMN
{
	LPCTSTR lpszHeader;
	int nWidth;
} COLUMN_PROP;

const int MAX_LEN_SECTION = 21;
const LPCTSTR DEFAULT_EXT_LIST = _T("html,htm,asp");

class CMainFrame;
class CReplacerDoc;

/////////////////////////////////////////////////////////////////////////////
// CDataObj command target

class CDataObj : public CCmdTarget
{
	DECLARE_DYNCREATE(CDataObj)

	CDataObj();           // protected constructor used by dynamic creation

// Attributes
public:
	CDataObj(const CDataObj &dataObj);
	CDataObj& operator=(const CDataObj &dataObj);
	vector<CSctipt> m_arrScripts;
	CString m_strDataFolder;
	CString m_strSourceFolder;
	BOOL m_bSubFolders;
	INT m_nCount;
	CFiler m_filer;
	BOOL m_bAutoDelNotExist;

// Operations
public:
	BOOL UpdateSource();
	BOOL UpdateAll(HWND hWndList);
	BOOL Replace(HWND hWndList, CString& strFileName);
	BOOL Add(HWND hWndList, CString& strFileName);
	BOOL DeleteSelected(HWND hWndList);
	BOOL FillContents(HWND hWndList);
	BOOL InitColumns(HWND hWndList);
	BOOL SaveData();
	BOOL ReadData();
	BOOL GetScriptInfo(LPCTSTR lpszFile, CString& strBegin, CString& strEnd);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDataObj)
	//}}AFX_VIRTUAL

// Implementation
	virtual ~CDataObj();
protected:
	BOOL InsertBack(HWND hWndList);
	BOOL ReplaceSelected(HWND hWndList, const CString strFileName, const CString strBegine, const CString strEnd, const CString strPath);
	BOOL UpdateInFolder(CMainFrame* pWnd, CReplacerDoc* pDoc, LPCTSTR lpszSourceFolder, BOOL bCountOnly = FALSE);
	BOOL UpdateFile(CMainFrame* pWnd, CReplacerDoc* pDoc, LPCTSTR lpszSourceFolder, LPCTSTR lpszFileName);
	ULONG m_nFiles;
	ULONG m_nAllFiles;

	// Generated message map functions
	//{{AFX_MSG(CDataObj)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	static COLUMN_PROP m_columns_prop[];
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATAOBJ_H__B5C0B4E1_5CA0_11D4_9F3D_009027A4D0CE__INCLUDED_)
