// Filer.cpp: implementation of the CFiler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Replacer.h"

#include "MainFrm.h"

#include "Sctipt.h"
#include "Filer.h"
#include "DataObj.h"

#include "ReplacerDoc.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFiler::CFiler() : m_stream(NULL), m_stream_tmp(NULL), m_stream_scr(NULL)
{
}

CFiler::~CFiler()
{
	Close();
	_flushall();
}

BOOL CFiler::Close()
{
	if (m_stream_scr != NULL)
	{
		if (fclose(m_stream_scr) == 0)
		{
			m_stream_scr = NULL;
		}
	}
	if (m_stream_tmp != NULL)
	{
		if (fclose(m_stream_tmp) == 0)
		{
			m_stream_tmp = NULL;
		}
	}
	if (m_stream != NULL)
	{
		if (fclose(m_stream) == 0)
		{
			m_stream = NULL;
			return TRUE;
		}
		else
			return FALSE;
	}
	return TRUE;
}

inline BOOL CFiler::IsMarker()
{
	// The first char is '<'
	LPCTSTR lpchr;
	return ((lpchr = _tcschr(m_buffer, '<')) != NULL && lpchr-m_buffer == 0);
}

BOOL CFiler::GetScriptInfo(LPCTSTR lpszFile, 
	LPTSTR lpszBegin, int nBegin,  LPTSTR lpszEnd, int nEnd)
{
	if (!Close()) return FALSE;
	m_stream = _tfopen(lpszFile, _T("rt"));
	if (m_stream == NULL) return FALSE;
	
	BOOL bIsBegine = FALSE;
	_tcscpy(lpszBegin, _T(""));
	_tcscpy(lpszEnd, _T(""));
	rewind(m_stream);
	while(_fgetts(m_buffer, MAX_BUFF_LEN, m_stream) != NULL)
	{
		if (IsMarker())
		{
			if (!bIsBegine)
			{
				bIsBegine = TRUE;
				if (_tcslen(m_buffer) > nBegin)
					_tcsncpy(lpszBegin, m_buffer, (size_t)nBegin);
				else
					_tcscpy(lpszBegin, m_buffer);
			}
			else
			{
				if (_tcslen(m_buffer) > nEnd)
					_tcsncpy(lpszEnd, m_buffer, (size_t)nEnd);
				else
					_tcscpy(lpszEnd, m_buffer);
			}
		}
	}
	Close();
	return (_tcslen(lpszBegin) > 0 && _tcslen(lpszEnd) > 0);
}

BOOL CFiler::IsFile(LPCTSTR lpszFileName)
{
	DWORD dwCode = GetFileAttributes(lpszFileName);
	return (dwCode != -1);
}

BOOL CFiler::UpdateFile(CMainFrame* pWnd, CReplacerDoc* pDoc, LPCTSTR lpszFileName, vector<CSctipt>* pArrScripts)
{
	if (!Close()) return FALSE;
	m_stream = _tfopen(lpszFileName, _T("rt"));
	if (m_stream == NULL) return FALSE;

	BOOL bIsBegin = FALSE;
	CString strScrFile;
	fpos_t posBegin = NULL;
	fpos_t posEnd = NULL;
	vector<CSctipt>::iterator iter;
	vector<SCRIPTPOS> arrScriptPos;
	LPCTSTR lpszCurScript;
	
	// Step1 - Search contents scripts in file
	rewind(m_stream);
	while(_fgetts(m_buffer, MAX_BUFF_LEN, m_stream) != NULL)
	{
		for(iter = pArrScripts->begin(); iter != pArrScripts->end(); iter++)
		{
			if (!bIsBegin)
			{
				// Check BeginMark
				if (_tcsstr(m_buffer, LPCTSTR((*iter).m_strBeginMark)) != NULL)
				{
					// Get script file name and begin pos
					strScrFile = LPCTSTR((*iter).m_strPath);
					strScrFile += LPCTSTR((*iter).m_strFileName);
					if (fgetpos(m_stream, &posBegin) == 0)
						bIsBegin = TRUE;
				}
			}
			else
			{
				// Check EndMark
				if (_tcsstr(m_buffer, LPCTSTR((*iter).m_strEndMark)) != NULL)
				{
					// Get end pos and add into vector arrScriptPos
					if (fgetpos(m_stream, &posEnd) == 0)
					{
						arrScriptPos.push_back(SCRIPTPOS(posBegin, posEnd, strScrFile)); 
						bIsBegin = FALSE;
					}
				}
			}
		}
	}

	BOOL bRetVal = TRUE;
	// Step2 - 
	if (arrScriptPos.size())
	{
		bRetVal = FALSE;
		// Is script in file
		LPCTSTR lpextp = NULL;
		_TCHAR szNewFileName[_MAX_PATH];
		if ((lpextp = _tcsrchr(lpszFileName,'.')) != NULL)
		{
			// Create new temp file
			int nLen = lpextp-lpszFileName+1;
			_tcsncpy(szNewFileName, lpszFileName, nLen);
			szNewFileName[nLen]= (_TCHAR)NULL;
			_tcscat(szNewFileName, _T("tmp")); 
			m_stream_tmp = _tfopen(szNewFileName, _T("wt"));
			if (m_stream_tmp != NULL)
			{
				BOOL bSkipLast = FALSE;
				BOOL bRest = FALSE;
				bIsBegin = FALSE;
				vector<SCRIPTPOS>::iterator iterFp = arrScriptPos.begin();
				posBegin = (*iterFp).posBegin;
				posEnd = (*iterFp).posEnd;
				fpos_t posCur = NULL;

				rewind(m_stream);
				while(_fgetts(m_buffer, MAX_BUFF_LEN, m_stream) != NULL)
				{
					if (!bRest)
					{
						if (fgetpos(m_stream, &posCur) == 0)
						{
							if (!bIsBegin)
							{
								if (posBegin == posCur)
								{
									// Found begin pos
									bIsBegin = TRUE;
								}
							}
							else
							{
								if (posEnd == posCur)
								{
									// Found end pos -> skip to next script
									lpszCurScript = LPCTSTR((*iterFp).strScriptName);
									CopyScript(lpszCurScript);
									if (pDoc != NULL)
										pDoc->AddScript(lpszCurScript);
									bSkipLast = TRUE;
									// Skip to next script
									bIsBegin = FALSE;
									if (++iterFp != arrScriptPos.end())
									{
										// Is next script
										posBegin = (*iterFp).posBegin;
										posEnd = (*iterFp).posEnd;
									}
									else
									{
										// no more
										posBegin = NULL;
										posEnd = NULL;
										bRest = TRUE;
									}
								}
							}
						}
					}
					if (!bIsBegin && !bSkipLast)
						_fputts(m_buffer, m_stream_tmp);
					if (bSkipLast)
					{
						_fputts(_T("\n"), m_stream_tmp);
						bSkipLast = FALSE;
					}
				}
				if (m_stream_tmp != NULL)
				{
					if (fclose(m_stream_tmp) == 0)
					{
						m_stream_tmp = NULL;
					}
				}
				Close();
				if (_tremove(lpszFileName) == 0)
				{
					if(_trename(szNewFileName,lpszFileName) == 0) 
						bRetVal = TRUE;
				}
			}
		}
	}
	
	Close();
	return bRetVal;
}

BOOL CFiler::CopyScript(LPCTSTR lpszFromFile)
{
	if (m_stream_tmp == NULL) return FALSE;
	if (!IsFile(lpszFromFile)) return FALSE;	
	
	m_stream_scr = _tfopen(lpszFromFile, _T("rt"));
	if (m_stream_scr == NULL) return FALSE;
	
	rewind(m_stream_scr);
	while(_fgetts(m_buffer_scr, MAX_BUFF_LEN, m_stream_scr) != NULL)
	{
		_fputts(m_buffer_scr, m_stream_tmp);
	}
	
	if (m_stream_scr != NULL)
	{
		if (fclose(m_stream_scr) == 0)
		{
			m_stream_scr = NULL;
		}
	}
	return TRUE;
}