// PropPage1.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Replacer.h"

#include "Source.h"

#include "Sctipt.h"
#include "Filer.h"
#include "DataObj.h"

#include "PropPage1.h"

#include "ReplacerDoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CPropPage1, CPropertyPage)
IMPLEMENT_DYNCREATE(CPropPage2, CPropertyPage)


/////////////////////////////////////////////////////////////////////////////
// CPropPage1 property page

CPropPage1::CPropPage1() : CPropertyPage(CPropPage1::IDD)
{
	//{{AFX_DATA_INIT(CPropPage1)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPropPage1::~CPropPage1()
{
}

void CPropPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPage1)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPage1)
	ON_BN_CLICKED(IDC_CHKSUBFOLDER, OnChkSubfolder)
	ON_EN_CHANGE(IDC_DATA_FOLDER, OnChangeDataFolder)
	ON_EN_CHANGE(IDC_SOURCE_FOLDER, OnChangeSourceFolder)
	ON_BN_CLICKED(IDC_BTN_SOURCE, OnBtnSource)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CPropPage1::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Get pDoc
	CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
	VERIFY(pWnd != NULL);
	CReplacerDoc* pDoc = (CReplacerDoc*)pWnd->GetActiveDocument();
	VERIFY(pDoc != NULL);
	
	CDataObj* pDataObj = &pDoc->m_dataObj;
	VERIFY(pDataObj != NULL);

	// Init data from CDataObj
	SetDlgItemText(IDC_DATA_FOLDER, pDataObj->m_strDataFolder); 
	SetDlgItemText(IDC_SOURCE_FOLDER, pDataObj->m_strSourceFolder);
	CheckDlgButton(IDC_CHKSUBFOLDER, (pDataObj->m_bSubFolders ? BST_CHECKED : BST_UNCHECKED));   
	
	m_bIsModified = FALSE;
	
	return TRUE;
}

void CPropPage1::OnOK() 
{
	if (m_bIsModified)
	{
		// Get pDoc
		CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
		VERIFY(pWnd != NULL);
		CReplacerDoc* pDoc = (CReplacerDoc*)pWnd->GetActiveDocument();
		VERIFY(pDoc != NULL);
		
		CDataObj* pDataObj = &pDoc->m_dataObj;
		VERIFY(pDataObj != NULL);

		// Save data into CDataObj
		GetDlgItemText(IDC_DATA_FOLDER, pDataObj->m_strDataFolder); 
		GetDlgItemText(IDC_SOURCE_FOLDER, pDataObj->m_strSourceFolder);
		pDataObj->m_bSubFolders = (BOOL)IsDlgButtonChecked(IDC_CHKSUBFOLDER); 
		m_bIsModified = FALSE;
		
		// Apply changes
		pDoc->ApplyChange(1);
	}	

	CPropertyPage::OnOK();
}

void CPropPage1::MkChange(BOOL bIsModified)
{
	m_bIsModified = bIsModified;
	if (m_bIsModified) SetModified(); 
}

void CPropPage1::OnChkSubfolder() 
{
	MkChange();
}

void CPropPage1::OnChangeDataFolder() 
{
	MkChange();
}

void CPropPage1::OnChangeSourceFolder() 
{
	MkChange();
}

void CPropPage1::OnBtnSource() 
{
	// Get list extensions
	CString strDataFolder;
	GetDlgItemText(IDC_DATA_FOLDER, strDataFolder);
	
	// Build filter
	CString strExts;
	int nSepLast = 0;
	int nSepCur = strDataFolder.Find(',', nSepLast);
	while (nSepCur != -1)
	{
		strExts += _T("*.");
		strExts += strDataFolder.Mid(nSepLast, nSepCur-nSepLast);
		strExts += _T(";");
		nSepLast = ++nSepCur; 
		nSepCur = strDataFolder.Find(',', nSepLast);
	}
	strExts += _T("*.");
	strExts += strDataFolder.Mid(nSepLast);

	CString strFilter(_T("Source Files ("));
	strFilter += strExts;
	strFilter += _T(")|");
	strFilter += strExts;
	strFilter += _T("|All Files (*.*)|*.*||");
	
	// Get curdir
	TCHAR szCurDir[_MAX_PATH];
	DWORD dwCode = GetCurrentDirectory((DWORD)_MAX_PATH, szCurDir);
	BOOL bChangedDir = FALSE;

	// Reset cur dir if need 
	CString strSourceFolder;
	GetDlgItemText(IDC_SOURCE_FOLDER, strSourceFolder);
	if (strSourceFolder.Find('\\') != -1)
		if (dwCode)
			bChangedDir = SetCurrentDirectory(strSourceFolder);

	// Get file from Open dialog
	CFileDialog dlgFile(
		TRUE,
		NULL,
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		strFilter);
	
	if (dlgFile.DoModal() == IDOK)
	{
		// Set new folder
		CString strFile, strPath;
		strFile = dlgFile.GetFileName();
		strPath = dlgFile.GetPathName();
		SetDlgItemText(IDC_SOURCE_FOLDER,
			strPath.Left(strPath.GetLength()-strFile.GetLength()));
		MkChange();
	}

	// Restore cur dir
	if (dwCode)
		SetCurrentDirectory(szCurDir);
}

/////////////////////////////////////////////////////////////////////////////
// CPropPage2 property page

CPropPage2::CPropPage2() : CPropertyPage(CPropPage2::IDD)
{
	//{{AFX_DATA_INIT(CPropPage2)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPropPage2::~CPropPage2()
{
}

void CPropPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPage2)
	DDX_Control(pDX, IDC_LIST1, m_listCtrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPropPage2, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPage2)
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, OnRclickList1)
	ON_COMMAND(ID_SHORTCUT_ADD, OnShortcutAdd)
	ON_COMMAND(ID_SHORTCUT_REPLACE, OnShortcutReplace)
	ON_COMMAND(ID_SHORTCUT_DELETE, OnShortcutDelete)
	ON_COMMAND(ID_SHORTCUT_UPDATEALL, OnShortcutUpdateAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CPropPage2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// Get pDoc
	CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
	VERIFY(pWnd != NULL);
	CReplacerDoc* pDoc = (CReplacerDoc*)pWnd->GetActiveDocument();
	VERIFY(pDoc != NULL);
	
	// Get HWND CListViewCtrl
	m_hWndList = m_listCtrl.GetSafeHwnd();
	VERIFY(m_hWndList != NULL); 

	// Reset style 
	DWORD dwStyle = ListView_GetExtendedListViewStyle(m_hWndList);
	dwStyle |= LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT;
	ListView_SetExtendedListViewStyle(m_hWndList, dwStyle);
	
	// Init data from CDataObj
	m_dataObj = pDoc->m_dataObj;
	m_dataObj.InitColumns(m_hWndList);
	m_dataObj.FillContents(m_hWndList);
	
	m_bIsModified = FALSE;
	
	return TRUE;
}

void CPropPage2::ShowMenu()
{
	CMenu menu;
	if (menu.LoadMenu(IDR_SHORTCUT1) && menu.GetMenuItemCount())
	{
        CMenu* pPopup = menu.GetSubMenu(0);
        VERIFY(pPopup != NULL);
		CWnd* pWnd = GetOwner(); 
        VERIFY(pWnd != NULL);
		POINT pt;
		GetCursorPos(&pt);
		
		// Set EnableMenuItem
		VERIFY(m_hWndList);
		int nCount = ListView_GetItemCount(m_hWndList);
		UINT nSelectedCount = 0;
		if (nCount)
		{
			nSelectedCount = ListView_GetSelectedCount(m_hWndList); 
			if (nSelectedCount == 0)
			{
				pPopup->EnableMenuItem(ID_SHORTCUT_REPLACE, MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
				pPopup->EnableMenuItem(ID_SHORTCUT_DELETE,  MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);
			}
		}
		else
			pPopup->EnableMenuItem(ID_SHORTCUT_UPDATEALL, MF_BYCOMMAND|MF_DISABLED|MF_GRAYED);

		pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,
            pt.x, pt.y, pWnd);
    }
}

void CPropPage2::OnRclickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ShowMenu();
	*pResult = 0;
}

void CPropPage2::MkChange(BOOL bIsModified)
{
	m_bIsModified = bIsModified;
	if (m_bIsModified) SetModified(); 
}

BOOL CPropPage2::GetFile(CString &strFileName)
{
	// Get CurrentDirectory from selected item
	VERIFY(m_hWndList);
	TCHAR szCurDir[_MAX_PATH];
	TCHAR szOldCurDir[_MAX_PATH];
	BOOL bChangedDir = FALSE;
	DWORD dwCode = GetCurrentDirectory((DWORD)_MAX_PATH, szOldCurDir);
	int nItem = -1;
	int nCount = ListView_GetItemCount(m_hWndList);

	if (nCount)
	{
		if (ListView_GetSelectedCount(m_hWndList))
			nItem = ListView_GetNextItem(m_hWndList, -1, LVNI_SELECTED);
		else
			nItem = 0;
	}

	if (nItem != -1)
	{
		// Is seleteted item
		ListView_GetItemText(m_hWndList, nItem, 3, szCurDir, _MAX_PATH);
		if(_tcsrchr(szCurDir,'\\') != NULL)
		{
			// ... and it's directory -> reset to it
			if (dwCode)
				bChangedDir = SetCurrentDirectory(szCurDir);
		}
	}

	CFileDialog dlgFile(
		TRUE,
		NULL,
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		SCRIPT_EXT_LIST);
	
	BOOL bRetVal = FALSE;
	if (dlgFile.DoModal() == IDOK)
	{
		strFileName = dlgFile.GetPathName();
		bRetVal = TRUE;
	}

	// Restore CurrentDirectory
	if (dwCode)
		SetCurrentDirectory(szOldCurDir);
	return bRetVal;
}

void CPropPage2::OnShortcutAdd() 
{
	VERIFY(m_hWndList);
	CString strFileName;
	if (GetFile(strFileName) && 
		m_dataObj.Add(m_hWndList, strFileName))
	{
		MkChange();
	}
}

void CPropPage2::OnShortcutReplace() 
{
	VERIFY(m_hWndList);
	CString strFileName;
	if (GetFile(strFileName) &&
		m_dataObj.Replace(m_hWndList, strFileName))
	{
		MkChange();
	}
}

void CPropPage2::OnShortcutDelete() 
{
	VERIFY(m_hWndList);
	if (m_dataObj.DeleteSelected(m_hWndList))
		MkChange();
}

void CPropPage2::OnShortcutUpdateAll() 
{
	VERIFY(m_hWndList);
	if (m_dataObj.UpdateAll(m_hWndList))
		MkChange();
}

void CPropPage2::OnOK() 
{
	if (m_bIsModified)
	{
		// Get pDoc
		CFrameWnd* pWnd = (CFrameWnd*)AfxGetMainWnd();
		VERIFY(pWnd != NULL);
		CReplacerDoc* pDoc = (CReplacerDoc*)pWnd->GetActiveDocument();
		VERIFY(pDoc != NULL);
		
		// Save data into CDataObj
		pDoc->m_dataObj = m_dataObj;
		m_bIsModified = FALSE;
		
		// Apply changes
		pDoc->ApplyChange(2);
	}	
	CPropertyPage::OnOK();
}


