// ReplacerDoc.cpp : implementation of the CReplacerDoc class
//

#include "stdafx.h"
#include "Replacer.h"

#include "Source.h"

#include "Sctipt.h"
#include "Filer.h"
#include "DataObj.h"

#include "ReplacerDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReplacerDoc

IMPLEMENT_DYNCREATE(CReplacerDoc, CDocument)

BEGIN_MESSAGE_MAP(CReplacerDoc, CDocument)
	//{{AFX_MSG_MAP(CReplacerDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReplacerDoc construction/destruction

CReplacerDoc::CReplacerDoc() : m_bIsModified(FALSE)
{
}

CReplacerDoc::~CReplacerDoc()
{
	RemoveAllSource();

	if (m_bIsModified)
	{
		m_dataObj.SaveData();
		m_bIsModified = FALSE;
	}
}

BOOL CReplacerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	
	// Read document data 
	m_dataObj.ReadData();
	ApplyChange();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CReplacerDoc diagnostics

#ifdef _DEBUG
void CReplacerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CReplacerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReplacerDoc commands

void CReplacerDoc::RemoveAllSource()
{
	int nBoundScr = m_arrSources.GetUpperBound();
	if (nBoundScr != (-1))
	{
		// delete all script objects from memory
		CSource* pScrObj = NULL;
		for (int nIndex = nBoundScr; nIndex > -1; nIndex--)
		{
			pScrObj = (CSource*)m_arrSources.GetAt(nIndex);
			if (pScrObj != NULL)
				delete pScrObj;
		}
		pScrObj = NULL;
		m_arrSources.RemoveAll(); 
	}
}

void CReplacerDoc::MkChange(BOOL bIsChanged)
{
	m_bIsModified = bIsChanged;
}

BOOL CReplacerDoc::IsChanges()
{
	return m_bIsModified;
}

void CReplacerDoc::ApplyChange(int nPropPage)
{
	MkChange();
	if (nPropPage == 1)
		SetTitle(m_dataObj.m_strSourceFolder);
}

void CReplacerDoc::PrepUpdateSource()
{
	RemoveAllSource();
}

BOOL CReplacerDoc::AddSource(LPCTSTR lpszPath, LPCTSTR lpszFileName, LPCTSTR lpszScriptName)
{
	CSource* pSrcObj = new CSource(lpszPath, lpszFileName, lpszScriptName);
	if (pSrcObj != NULL)
	{
		m_arrSources.Add((CObject*)pSrcObj);
//		UpdateAllViews(NULL);  
		return TRUE;
	}
	return FALSE;
}

BOOL CReplacerDoc::AddSource(LPCTSTR lpszPath, LPCTSTR lpszFileName)
{
	CSource* pSrcObj = new CSource(lpszPath, lpszFileName);
	if (pSrcObj != NULL)
	{
		m_arrSources.Add((CObject*)pSrcObj);
//		UpdateAllViews(NULL);  
		return TRUE;
	}
	return FALSE;
}

BOOL CReplacerDoc::AddScript(LPCTSTR lpszFileName)
{
	// Add script to last source object
	int nIndex = m_arrSources.GetUpperBound();
	if (nIndex != -1)
	{
		CSource* pSrcObj = (CSource*)m_arrSources.GetAt(nIndex);
		if (pSrcObj != NULL)
		{
			pSrcObj->m_arrScripts.Add(lpszFileName);
//			UpdateAllViews(NULL);  
			return TRUE;
		}
	}
	return FALSE;
}

DOCSIZE CReplacerDoc::GetDocSize()
{
	ULONG nRows = 0;
	ULONG nMaxLenFolder = 0;
	ULONG nMaxLenSource = 0;
	ULONG nMaxLenScript = 0;
	int nSize = m_arrSources.GetSize();
	if (nSize)
	{
		CString strCurParh;
		CSource* pSrcObj = NULL; 
		int nScr = 0;
		int nScrs = 0;
		for (int nIdex = 0; nIdex < nSize; nIdex++)
		{
			
			pSrcObj = (CSource* )m_arrSources.GetAt(nIdex);
			if (pSrcObj != NULL)
			{
				if (strCurParh != pSrcObj->m_strPath)
				{
					// New folder
					strCurParh = pSrcObj->m_strPath;
					nMaxLenFolder = __max(nMaxLenFolder, (ULONG)strCurParh.GetLength());  
					nRows++;
				}
				// source
				nMaxLenSource = __max(nMaxLenSource,
					(ULONG)(pSrcObj->m_strFileName.GetLength()));  
				nRows++;
				nScrs = pSrcObj->m_arrScripts.GetSize();
				if (nScrs)
				{
					// Disply all scripts
					for(nScr = 0; nScr < nScrs; nScr++)
					{
						nMaxLenScript = __max(nMaxLenScript,
							(ULONG)(pSrcObj->m_arrScripts.GetAt(nScr).GetLength()));  
						nRows++;
					}
				}
			}
		}
	}
	return DOCSIZE(nRows, nMaxLenFolder, nMaxLenSource, nMaxLenScript);
}

