// ReplacerView.cpp : implementation of the CReplacerView class
//

#include "stdafx.h"
#include "Replacer.h"

#include "Source.h"

#include "Sctipt.h"
#include "Filer.h"
#include "DataObj.h"

#include "ReplacerDoc.h"
#include "ReplacerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CReplacerView

IMPLEMENT_DYNCREATE(CReplacerView, CScrollView)

BEGIN_MESSAGE_MAP(CReplacerView, CScrollView)
	//{{AFX_MSG_MAP(CReplacerView)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReplacerView construction/destruction

CReplacerView::CReplacerView() : m_nRowHeight(0), m_nAveCharWidth(0)
{
	// TODO: add construction code here

}

CReplacerView::~CReplacerView()
{
}

BOOL CReplacerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CReplacerView drawing

void CReplacerView::OnDraw(CDC* pDC)
{
	CReplacerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	UpdateScrollSizes();
	
	int nCurHeight = 0;
	int nSize =  pDoc->m_arrSources.GetSize();
	if (nSize)
	{
		CString strCurParh;
		CSource* pSrcObj = NULL; 
		int nScr = 0;
		int nScrs = 0;
		for (int nIdex = 0; nIdex < nSize; nIdex++)
		{
			pSrcObj = (CSource* )pDoc->m_arrSources.GetAt(nIdex);
			if (pSrcObj != NULL)
			{
				if (strCurParh != pSrcObj->m_strPath)
				{
					// Disply new folder
					strCurParh = pSrcObj->m_strPath;
					pDC->TextOut(LEFTPOSFOLDER, nCurHeight, strCurParh); 
					nCurHeight += m_nRowHeight;
				}
				// Disply source
				pDC->TextOut(LEFTPOSSOURCE, nCurHeight, pSrcObj->m_strFileName); 
				nCurHeight += m_nRowHeight;
				nScrs = pSrcObj->m_arrScripts.GetSize();
				if (nScrs)
				{
					// Disply all scripts
					for(nScr = 0; nScr < nScrs; nScr++)
					{
						pDC->TextOut(LEFTPOSSCRIPT, nCurHeight, pSrcObj->m_arrScripts.GetAt(nScr)); 
						nCurHeight += m_nRowHeight;
					}
				}
			}
		}
	}
}

void CReplacerView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	
	CClientDC dc(this);
	TEXTMETRIC tm;
	dc.GetTextMetrics(&tm);
	m_nRowHeight = tm.tmHeight + tm.tmExternalLeading;
	m_nAveCharWidth = tm.tmAveCharWidth;
	UpdateScrollSizes();
}

/////////////////////////////////////////////////////////////////////////////
// CReplacerView printing

BOOL CReplacerView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CReplacerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CReplacerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CReplacerView diagnostics

#ifdef _DEBUG
void CReplacerView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CReplacerView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CReplacerDoc* CReplacerView::GetDocument() // non-debug version is inline
{
	VERIFY(m_pDocument->IsKindOf(RUNTIME_CLASS(CReplacerDoc)));
	return (CReplacerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReplacerView message handlers

LRESULT CReplacerView::OnApplyChanges(WPARAM wp, LPARAM lp)
{
//	ApplyChange();
	return (LRESULT)0;
}

void CReplacerView::UpdateScrollSizes()
{
	DOCSIZE stDocSize = GetDocument()->GetDocSize();
	int nRows = (int)stDocSize.nRows;
	int nMaxWidthLine =
		LEFTPOSFOLDER+m_nAveCharWidth*(int)stDocSize.nMaxLenFolder;	
	nMaxWidthLine = max(nMaxWidthLine,
		LEFTPOSSOURCE+m_nAveCharWidth*(int)stDocSize.nMaxLenSource); 
	nMaxWidthLine = max(nMaxWidthLine,
		LEFTPOSSCRIPT+m_nAveCharWidth*(int)stDocSize.nMaxLenScript);
	
	CRect rect;
	GetClientRect(&rect);
	CSize sizePage(rect.right, rect.bottom);
	CSize sizeTotal(nMaxWidthLine, nRows*m_nRowHeight);
	CSize sizeLine(nMaxWidthLine, m_nRowHeight);
	SetScrollSizes(MM_TEXT, sizeTotal, sizePage, sizeLine);
}

/////////////////////////////////////////////////////////////////////////////
// CReplacerView message handlers

void CReplacerView::ShowMenu()
{
	CMenu menu;
	if (menu.LoadMenu(IDR_SHORTCUT2) && menu.GetMenuItemCount())
	{
        CMenu* pPopup = menu.GetSubMenu(0);
        VERIFY(pPopup != NULL);
		CWnd* pWnd = GetOwner(); 
        VERIFY(pWnd != NULL);
		POINT pt;
		GetCursorPos(&pt);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,
            pt.x, pt.y, pWnd);
    }
}

void CReplacerView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	ShowMenu();
	CScrollView::OnRButtonDown(nFlags, point);
}
